﻿using EvaPosSCOSrv;
using Serilog.Events;
using Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.Net;
using gatewayGK.Infraestructura;
using Microsoft.Extensions.Configuration;

namespace gatewayGK.Servidor
{
    public class PosbcServerConnect
    {
        ILogger log = Log.ForContext<ServidorSocket>();
        readonly static bool _isDebug = Log.IsEnabled(LogEventLevel.Debug);
        /// <summary>
        /// Longitud máxima de mensaje de entrada.
        /// </summary>
        public const Int32 LongMaxMensaje = 1_024 * 8;
        /// <summary>
        /// Dirección ip para vincular el socket.
        /// </summary>
        public string Direccion { get; private set; } = "127.0.0.1";
        /// <summary>
        /// Puerto a vincular socket.
        /// </summary>
        public Int32 Puerto { get; private set; } = 6697;
        public int LongColaConexiones { get; private set; } = 10;
        /// <summary>
        /// Fija timeout usado para enviar / recibir em modo sincrónico, en milisegundos.
        /// Si el timeout se excede, se presenta una excepción. 
        /// Default a 5 segundos.
        /// </summary>
        public int TimeOutSincMs { get; private set; } = 3000;
        long _numeroConexionesEntrantes = 0;
        public PosbcServerConnect() { }

        public async Task ActivaServidor()
        {

            IConfiguration configBuilder = ConfigurationHelper.Configuration;


            string direccion = configBuilder["posbc:DireccionIpPosbc"];
            string puertoPosbcString = configBuilder["posbc:PuertoPosbc"];
            int puerto = int.Parse(puertoPosbcString);

            IPEndPoint ipEndPoint = new(IPAddress.Parse(direccion), puerto);
            int cont = 0;
            using Socket tcpSocket = new(
                ipEndPoint.AddressFamily,
                SocketType.Stream,
                ProtocolType.Tcp);

            await tcpSocket.ConnectAsync(ipEndPoint);


            log.Information("Posbc servidor socket en {ip} : {puerto}, proceso id {id}", Direccion, Puerto);
            
            Socket socketEntrada;
            try
            {
                while (true)
                {
                    log.Information("Esperando conexión POSBC...");

                }

            }
            catch (Exception ex)
            {
                log.Error("Error : {error}", ex);
            }
            finally
            {
                tcpSocket.Close();
            }


        }
    }
}
